// main.m

#import "ModelSwarm.h"

int main(int argc, const char ** argv)
    {
	ModelSwarm * modelSwarm;
	id <LispArchiver> archiver;
	
	initSwarm(argc, argv);

// create the modelSwarm
// load the parameters from file: first create an archiver instance,
// then load the parameters, with a check that the file exists, or that
// the key (modelSwarm) is in the file.	The LispArchiver also uses
// the createBegin and createEnd methods of the modelSwarm
	archiver=[LispArchiver create:globalZone setPath:"parameters.scm"];
	if((modelSwarm=[archiver getWithZone:globalZone key:"modelSwarm"])==nil)
		{
		raiseEvent(InvalidOperation,"can't find file or key\n");
		}
	[archiver drop];

// set the seed of the random generator so results can be reproduced
// (this is facultative)
	[randomGenerator setStateFromSeed:100000];	
	[modelSwarm buildObjects];
	[modelSwarm buildActions];
	[modelSwarm activateIn: nil];
	[[modelSwarm getActivity] run];
	return 0;
    }
