// consumer.h
// load program libraries
#import <objectbase.h>
//#import <objectbase/Swarm.h>
#import <objectbase/SwarmObject.h>
#import <collections.h>
#import <random.h>
#import "Integer.h"

@interface Consumer:SwarmObject
    {
// define variables for the consumer
    int myBudget;
	int myMaxBudget;
    int myName;
	int moneySpent;
	int marketGoer;
	id <List> listOfSpending;
	id <Array> arrayOfVisits;
	int currentTime;
	int positionX,positionY;
    }

// define methods for the consumer
// this method passes values for the consumer variables
-setConsumerName:(int)name MaxBudget:(int)maxBudget StartBudget:(int)startBudget Goer:(int)goer;

// these methods deal with the positioning of the consumer
// on the space
-setPositionX:(int)x Y:(int)y;
// draw itself on the raster
-drawSelfOn:(id <ZoomRaster>)raster; 
// make the color of the agent depends on whether he is in the market or not
-(int)getStrategyColor; 

// methods to create the list of spending and the array of visits
-createListOfSpending:aZone;
-createArrayOfVisits:aZone:(int)size;

// this method draws a random number between 0 and
// maxBudget to determine the budget of the consumer
// (no need to pass arguments as myMaxBudget is a
// global variable for the consumer)
-(int)findBudget;

// this method draws a random number: returns 0 if the consumer
// stays home or 1 if he goes to the market
-(int) goToTheMarket;

// this method will only be used if the consumer goes to the
// market. It draws a random number from 0 to the value in myBudget
// and returns it: it is the amount spent.
-(int) spend;

// this method resets the budget of the consumer once the goods have
// been bought
-(int)calculateRemainingBudget;

// these methods are used to add elements to the list of spendings,
// and the array of visits. They will also take care of casting the
// (int) values into Integer objects
-updateSpending:(int)value;
-updateVisits:(int)offset:(int)value;

// these methods are needed to pass values of the consumer to other
// parts of the program
-(int)getConsumerName;
-(int)getBudget;
-(int)getVisitValue:(int)offset;
-(int)getSpendingValue;
-(int)getVisit;
-(int)getSpending;
-(int)getPositionX;
-(int)getPositionY;
-getAllSpending;
@end
