// modelSwarm.h

// load program libraries
#import <objectbase.h>
#import <objectbase/Swarm.h>
#import <objectbase/SwarmObject.h>
#import <activity.h>
#import <simtools.h>
#import <random.h>
#import <space.h>
#import <space/Discrete2d.h>
#import <space/Grid2d.h>
#import "Consumer.h"
#import "Integer.h"

@interface ModelSwarm:Swarm
	{
// here are declared variables which are global to the ModelSwarm class
	id <Schedule> modelSchedule;
	id <ActionGroup> modelActions;
	int modelTime;
	int maxTime;
	int startBudget;
	int maxBudget;
	int notFinished;
	int numberOfConsumers;
	id <List> listOfConsumers;
	int worldWidth,worldHeight;
	int sizeOfMarket;
	int xMin,yMin,xMax,yMax;
	id <Grid2d> world;
	id <Discrete2d> market;
	}

// creation methods which allow us to initialise parameters
+createBegin:(id) aZone;
-createEnd;
-setSimulationParameters:(int)simStartBudget;
// this method creates the consumers
-buildObjects;
// this method positions the consumers in the world, excluding the market,
// or only in the market according to the value of the last argument
-findPositionInWorld:(id <Grid2d>)aWorld For:(Consumer *)aGuy ExcludeMarket:(int)exclude;
// this method deals with what happens on a market
-marketDay;
// these methods deal with the running of the model
-increaseTime;
-(int)checkToStop;
-buildActions;
-activateIn: (id) swarmContext;
// these methods are used to get informations for characteristics
// of the model
-getListOfConsumers;
-getConsumer:(int)name;
-(int)getCurrentTime;
-(int)getWorldWidth;
-(int)getWorldHeight;
-getWorld;
-getMarket;
-getAllSpending;
@end
	
