// consumer.m
// load the header files
#import "Consumer.h"
#import "Integer.h"

@implementation Consumer
 
// define methods for the consumer
// this method passes values for the consumer variables
-(void)setConsumerName:(int)name MaxBudget:(int)maxBudget StartBudget:(int)startBudget;
	{
	myName=name;
	myBudget=startBudget;
	myMaxBudget=maxBudget;
	}

// methods to create the map of spending and the array of visits
-createMapOfSpending:aZone
	{
	mapOfSpending=[Map create:aZone];
	return self;
	}
	
-createArrayOfVisits:aZone:(int)size
	{
	// note, arrays are of fixed size, so they need the setCount method
	// when created
	arrayOfVisits=[Array create:aZone setCount:size];
	return self;
	}

// this method draws a random number between 0 and
// maxBudget to determine the budget of the consumer
// (no need to pass arguments as myMaxBudget is a
// global variable for the consumer)
-(int)findBudget
	{
	// take myBudget and add to it a random variable between
	// 0 and myMaxBudget (need to add as myBudget may not
	// be 0 (if not all was spent))
	myBudget+=[uniformIntRand getIntegerWithMin:0 withMax:myMaxBudget];
	return myBudget;
	}

// this method draws a random number: returns 0 if the consumer
// stays home or 1 if he goes to the market
-(int) goToTheMarket
	{
	int k;
	k=[uniformIntRand getIntegerWithMin:0 withMax:1];
	return k;
	}

// this method will only be used if the consumer goes to the
// market. It draws a random number from 0 to the value in myBudget
// and returns it: it is the amount spent.
-(int) spend
	{
	moneySpent=[uniformIntRand getIntegerWithMin:0 withMax:myBudget];
	return moneySpent;
	}

// this method resets the budget of the consumer once the goods have
// been bought
-(int) calculateRemainingBudget
	{
	myBudget-=moneySpent;
	return myBudget;
	}

// these methods are used to add elements to the map of spendings,
// and the array of visits. They will also take care of casting the
// (int) values into Integer objects
-updateSpending:(int)key:(int)value
	{
	Integer * keyObject;
	Integer * valueObject;

	keyObject=[Integer create:[self getZone]];
	[keyObject setValue:key];
	valueObject=[Integer create:[self getZone]];
	[valueObject setValue:value];

	[mapOfSpending at:keyObject insert:valueObject];
	return self;
	}
	
-updateVisits:(int)offset:(int)value
	{
	Integer * valueObject;
// set the currentTime (equivalent to modelTime)
	currentTime=offset;
	valueObject=[Integer create:[self getZone]];
	[valueObject setValue:value];

	[arrayOfVisits atOffset:offset put:valueObject];
	return self;
	}

// these methods are needed to pass values of the consumer to other
// parts of the program
-(int)getConsumerName
	{
	return myName;
	}
	
-(int)getBudget
	{
	return myBudget;
	}

// get value at offset, in arrayOfVisits
-(int)getVisitValue:(int)offset
	{
	Integer * element;
	element=[arrayOfVisits atOffset:offset];
	return [element getMyValue];
	}

// get value of element at key
-(int)getSpendingValue:(int)key
	{
	Integer * keyObject;
	Integer * element;
	keyObject=[Integer create:[self getZone]];
	[keyObject setValue:key];
	element=[mapOfSpending at:keyObject];
	return [element getMyValue];
	}

-(int)getVisit
	{
	return [self getVisitValue:currentTime];
	}

-(int)getSpending
	{
	return [self getSpendingValue:currentTime];
	}
@end
