// ModelSwarm.m

#import "ModelSwarm.h"

@implementation ModelSwarm

+createBegin: (id) aZone
	{
	ModelSwarm * obj;

// call the createBegin method of the superClass
	obj = [super createBegin: aZone];
// initialise time variable
	obj -> modelTime=0;
	obj -> maxTime=5;
	obj -> numberOfConsumers=3;
	obj -> startBudget=0; // no endowment
	obj -> maxBudget=10;
	obj -> notFinished=1;
	return obj;
	}

-createEnd
  {
  return [super createEnd];
  }

-buildObjects
	{
	int i;
	int name;

// create the list of consumers
	listOfConsumers=[List create:[self getZone]];

// iterate over all possible consumers (from 1 to numberOfConsumers)
	for (i=1;i<=numberOfConsumers;++i)
		{
		Consumer * aConsumer;
// name of consumer=index i
		name=i;
// create the consumers
	    aConsumer=[Consumer create: [self getZone]];
   		[aConsumer setConsumerName:name MaxBudget:maxBudget StartBudget:startBudget];
// create the map and arrays (the array is created with a size of
// maxTime+1, as time starts at 0
		[aConsumer createMapOfSpending:[self getZone]];
		[aConsumer createArrayOfVisits:[self getZone]:maxTime+1];
// add consumer to the list
		[listOfConsumers addFirst:aConsumer];
		}
	return self;
	}

-marketDay
	{
	int go;
	int spending;
	int budget;
	id <Index> i=nil; // to iterate over the list of consumers
	Consumer * listElement;
	
// iterate over the list of consumers
// first, create the index i
	i=[listOfConsumers begin:[self getZone]];
	while ((listElement=[i next])!=nil)
		{
// update the budget of the consumer
		budget=[listElement findBudget];

// is he going to the market?
		go=[listElement goToTheMarket];
	    if (go)
       		{
	        spending=[listElement spend];
// add 1 to arrayOfVisits, at the position corresponding to
// current modelTime
			[listElement updateVisits:modelTime:1];
// add spending at the key modelTime in the mapOfSpending
			[listElement updateSpending:modelTime:spending];
// now, print a report of the consumer's actions
			printf("This is time %d\n",modelTime);
	        printf("I am consumer %d\n",[listElement getConsumerName]);
			printf("My current budget is %d\n",[listElement getBudget]);
			printf("Did I go to the market? %d (from array)\n",[listElement getVisitValue:modelTime]);
			printf("I spent %d (from map)\n",[listElement getSpendingValue:modelTime]);
       		printf("I have %d of currency left.\n",[listElement calculateRemainingBudget]);
       		}
	    else
       		{
// add 0 to arrayOfVisits at modelTime
			[listElement updateVisits:modelTime:0];
// add 0 to mapOfSpending at modelTime
			[listElement updateSpending:modelTime:0];
// print consumer's state
			printf("This is time %d\n",modelTime);
	        printf("I am consumer %d\n",[listElement getConsumerName]);
			printf("My current budget is %d\n",[listElement getBudget]);
			printf("Did I go to the market? %d (from array)\n",[listElement getVisitValue:modelTime]);
	        printf("I have %d of currency left.\n",[listElement getBudget]);
       		}
		}// end of iteration on listOfConsumers
// it is good practice to drop unused objects like indexes when they
// are no longer needed
		[i drop];
	return self;
	}

-increaseTime
	{
// at the end of a period, modelTime need to be increased by 1
	++modelTime;
	return self;
	}
-checkToStop
	{
// if modelTime<maxTime, then notFinished is 1, otherwhise it
// is 0
	if (modelTime<=maxTime)
		{
		notFinished=1;
		}
	else
		{
		notFinished=0;
// make sure the programs terminates and we are back to prompt
		[getTopLevelActivity() terminate];

		}
	return self;
	}

	
-buildActions
	{
// create an action group for the actions the model need to
// perform at each time period
// first, we tell people to go to the market (marketDay)
// then we increase the time of the model (increaseTime)
// finally we check whether this time is still valid (checkToStop)
	modelActions=[ActionGroup createBegin:self];
	modelActions=[modelActions createEnd];
	[modelActions createActionTo:self message:M(marketDay)];
	[modelActions createActionTo:self message:M(increaseTime)];
	[modelActions createActionTo:self message:M(checkToStop)];

// now schedule the actions in time
	modelSchedule = [Schedule createBegin: self];
	[modelSchedule setRepeatInterval:1];
	modelSchedule = [modelSchedule createEnd];
	[modelSchedule at: 0 createAction: modelActions];
	return self;
	}

-activateIn: (id) swarmContext
	{
	[super activateIn: swarmContext];
	[modelSchedule activateIn: self];
	
	return [self getActivity];
	}

@end